; 
;       LCD.
; 64   (32 ).
;      10 .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = SHKOLA.ASM
; : 06-02-05.
;   : MPLAB IDE, : 5.70.40.
;
            #INCLUDE P16F628.INC
            __CONFIG 3F09H
;==================================================================
;    4,096 .
;     4,  
;  TMR0 (256), ,  4    : 250, 2, 2
;    1  (444250256=4096000).
;==================================================================
; RA0 .
; RA5 -  : .
; RB2 - R/S - /, RB3 - E - ,
; RB4-RB7 - DB4-DB7-.  -.
; RB4-RB6 -  : , , ,
;============================================
;  .
;============================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  9AH  ; .
EEADR    EQU  9BH  ; .
EECON1   EQU  9CH  ; -
EECON2   EQU  9DH  ;.
;============================================
;   .
;============================================
R1	EQU	50H	;
R2	EQU	51H	;
R3	EQU	52H	;
R4	EQU	53H	;
R5	EQU	54H	;
R6	EQU	55H	;
R7	EQU	56H	;
R8	EQU	57H	;
R9	EQU	58H	;
R10	EQU	59H	;
R11	EQU	5AH	;
R12	EQU	5BH	;
R13	EQU	5CH	;
R14	EQU	5DH	;
R15	EQU	5EH	;
R16	EQU	5FH	;
;=====================================
;    .
;=====================================
SMC	EQU	20H	; .
SECL	EQU	21H	; .  
SECH	EQU	22H	; .
MINL	EQU	23H	; .
MINH	EQU	24H	; .
HOUL	EQU	25H	; .
HOUH	EQU	26H	; .
MIN	EQU	27H	;,  .
HOU	EQU	28H	;,  .
;==================================
; : , .
;==================================
YPOK	EQU	30H	;     .
YPOKH	EQU	31H	;  .
YPOKL	EQU	32H	;  .
KOPM	EQU	33H	; .
KOPH	EQU	34H	;  .
KOPL	EQU	35H	;  .
WTEMP	EQU	36H	;  W  .
STEMP	EQU	37H	;  STATUS  .
TEMP	EQU	38H	;  / .
FTEMP	EQU	39H	;  FSR.
EDI	EQU	3AH	;  .
DES	EQU	3BH	;  .
COUN	EQU	3CH	;   .
ZAN	EQU	3DH	;CT .
KYPC	EQU	3EH	;.
REID	EQU	3FH	; .
KOP	EQU	40H	;   .
BUH1	EQU	41H	;     (+).
BUM1	EQU	42H	;     (+).
BUH2	EQU	43H	;   .
BUM2	EQU	44H	;- .
BUH2L	EQU	45H	;  .
BUH2H	EQU	46H	;  .
BUM2L	EQU	47H	;  .
BUM2H	EQU	48H	;  .
BUM1L	EQU	49H	;  .
BUM1H	EQU	4AH	;  .
BUH1L	EQU	4BH	;  .
BUH1H	EQU	4CH	;  .
COUE	EQU	4DH	;    .
IBUHH	EQU	4EH	;  
IBUHL	EQU	4FH	; .
IBUMH	EQU	60H	;
IBUML	EQU	61H	;
IBUH	EQU	62H	;
IBUM	EQU	63H	;
COUZ	EQU	64H	;  .
ZVO	EQU	65H	; .
YPYK	EQU	66H	;  .
IBUH2	EQU	67H	; 
IBUM2	EQU	68H	; 
IBUH2H	EQU	69H	; 
IBUH2L	EQU	6AH	;.
IBUM2H	EQU	6BH	;
IBUM2L	EQU	6CH	;
;============================================
;     FLAG.
;============================================
FLAG	EQU	29H   
;
;     0->  .
;     1->  .
;     2-> 1/4   .
;     3->    .
;     4->  .
;     5->  , 1-.
;     6-> /.
;     7->  .
;============================================
;     FLAG1.
;============================================
FLAG1	EQU	2AH	;
;
;	0-> 1= .
;	    0=.
;	1-> .
;	2-> 0=      ,
;	    1=  .
;	3->   .
;	4->   .
;	5->   .
;	6->  / .
;	7-> 1 .
;============================================
;     FLAG3.
;============================================
FLAG3	EQU	2BH
;
;	1->  .
;	3->   2.
;	4->   2,   .
;	5-> 1-   ( ).
;========================================
RS	EQU	2	;/.
E	EQU	3	;.
YCT	EQU	6	;.
PAZ	EQU	5	;.
PEJ	EQU	4	;.
PR	EQU	5	;/. 
;======================
; 1. .
;======================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;=======================================
; 2.   .
;=======================================
VUBOR
	BTFSS	PORTB,PEJ	;  ,
	BSF	FLAG3,5		;
	BTFSS	PORTB,PAZ	;  ,
	BSF	FLAG3,5		;
	BTFSS	PORTB,YCT	;  ,
	BSF	FLAG3,5		; .
	MOVFW	REID		;  .
	ADDWF	PC,1		; . 
	GOTO	IND		;    .
	GOTO	INDPR		;  .
	GOTO	INDYH		;   .
	GOTO	INDYK		;  .
	GOTO	INDYV		;    .
;=======================================
; 3.   .
;=======================================
YCTA
	BTFSC	FLAG1,1		; ,
	RETURN			;  .
	BTFSS	FLAG1,0		;  ,
	RETURN			;  .
	BTFSS	PORTB,YCT	;  ,
	RETURN			;  .
	BCF	FLAG3,5		; .
	BCF	FLAG1,3		;  .
	MOVFW	KYPC		; 
	ADDWF	PC,1		;  .
	NOP			;   .
	NOP			;   .
	NOP			;   .
	NOP			;   .
	NOP			;   .
	NOP			;   .
	GOTO	YC5		;
	GOTO	YC6		;
	GOTO	YC7		;
	GOTO	YC8		;
	GOTO	YC9		;
	GOTO	YC10		;
	NOP			;   .
	GOTO	YC12		;
	GOTO	YC13		;
	GOTO	YC14		;
	GOTO	YC15		;
;========================================================
; 4.      .
;========================================================
DEBIN
	ADDWF	PC,1	;
	RETLW	.0
	RETLW	.10
	RETLW	.20
	RETLW	.30
	RETLW	.40
	RETLW	.50
;=========================================
; 5.  ().
;=========================================
RASPR
	BTFSS	FLAG,2		;  
	GOTO	$-1		; 1/4 .
	BCF	FLAG,2		; .
	BSF	STATUS,5	;   1.
	MOVLW	B'01110000'	;RB4-RB6 -  .
	MOVWF	TRISB^80H	;
	BCF	STATUS,5	;   0.
	CALL	KHOP		; .
	BSF	STATUS,5	;   1.
	MOVLW	B'00000000'	;RB0-RB7 -  .
	MOVWF	TRISB^80H	;
	BCF	STATUS,5	;   0.
	BTFSC	FLAG1,7		;  -  .
	CALL	COMP		;    .
	BTFSS	FLAG3,5		;     .
	CALL	JEKI		;.
	GOTO	RASPR		;.
;=========================================
; 6.  .
;=========================================
JEKYC
	MOVLW	.14	;  .
	CALL    JEKOM	; .
	CALL	JEKYK	;   .
	CALL    JEKOM	; .
	BSF	FLAG,6	;  - .
	GOTO	RASPR	;  .
JEKYK
	MOVFW	KYPC	;   .
	ADDWF	PC,1	;
	RETLW	0x0C	;   (  ).
	RETLW	0x80	;   
	RETLW	0x81	;
	RETLW	0x82	;
	RETLW	0x83	;
	RETLW	0x84	;
	RETLW	0x85	;
	RETLW	0x86	;
	RETLW	0x87	;
	RETLW	0xC0	;  ( 28) 0x0C0;
	RETLW	0xC1	;
	RETLW	0xC2	;
	RETLW	0xC3	;
	RETLW	0xC4	;
	RETLW	0xC5	;
	RETLW	0xC6	;
	RETLW	0xC7	;
;=================================================
; 7.      .
;=================================================
INDPR
	BTFSC	FLAG1,1	;   ,
	GOTO	PROCM	;
	MOVFW	YPYK	;    
	MOVWF	YPOK	;   .
	CALL	BIDE	;  .
	MOVWF	YPOKH	;
	MOVFW	TEMP	;
	MOVWF	YPOKL	;
	DECF	YPOK,0	;   1 
	MOVWF	COUE	; .
	BSF	FLAG1,1	; .
	BSF	FLAG1,0	; ,   .
	GOTO	CXUTKA	;  .
PROCM
	BTFSS	PORTA,PR;   ,
	BSF	FLAG1,6	; .
	BTFSS	PORTA,PR;   ,
	GOTO	PROSI	; .
	BTFSS	FLAG1,6	;  ,
	GOTO	PROSI	;
	BCF	FLAG1,6	; .
	TSTF	BUH1	;   ,
	SKPNZ		;( )
	CLRF	YPOK	;  .
	INCF	YPOK,1	;    .
	CALL	BIDE	;  2_10 .
	MOVWF	YPOKH	;
	MOVFW	TEMP	;
	MOVWF	YPOKL	;
	DECF	YPOK,0	;   1 
	MOVWF	COUE	; .
CXUTKA
	MOVFW	COUE	; .
	CALL	AKTETE	;   .
	MOVWF	BUH1	;  .
	CALL	PLUS	;
	MOVFW	COUE	; .
	CALL	AKTETE	;   .
	MOVWF	BUM1	;  .
	CALL	PLUS	;
	MOVFW	COUE	; .
	CALL	AKTETE	;   .
	MOVWF	BUH2	;  .
	CALL	PLUS	;
	MOVFW	COUE	; .
	CALL	AKTETE	;   .
	MOVWF	BUM2	;  .
	CALL	BINDEC	;  2_10 .
	BTFSC	FLAG1,1	;  ,  .
	GOTO	PROSI	;.
	RETURN		;
PLUS
	MOVLW	.32	;    32.
	ADDWF	COUE,1	;
	MOVLW	.128	;  
	SUBWF	COUE,0	;  128 (0-63).
	BTFSS	STATUS,2;
	RETURN		; .
	CLRF	COUE	; .
	RETURN		;
;=======================================
; 8.   2-  2_10.
;=======================================
BIDE
	MOVFW	YPOK	; .
	CLRF	COUN	; .
	ADDLW	-.10	; 10.
	BTFSS	STATUS,0;    ,
	GOTO	$+4	;  .
	MOVWF	TEMP	;     .
	INCF	COUN,1	; .
	GOTO	$-5	; .
	TSTF	COUN	;  ,
	SKPZ		;
	GOTO	$+3	;
	MOVFW	YPOK	;   
	MOVWF	TEMP	;   .
	MOVFW	COUN	;  (  )    .
	RETURN		;.
;======================================
; 9.    .
;======================================
KHOP
	BTFSC	FLAG1,3		;     ,
	CALL	YCTA		;    .
	BTFSS	PORTB,YCT	;  "" ,
	BSF	FLAG1,3		; .
	BTFSC	FLAG1,5		;     "",
	CALL	KYPCY		;    .
	BTFSS	PORTB,PAZ	;  "" ,
	BSF	FLAG1,5		; .
	BTFSC	FLAG1,4		;  ""  ,
	GOTO	$+4		;  .
	BTFSS	PORTB,PEJ	;  "" ,
	BSF	FLAG1,4		; .
	GOTO	VUBOR		;     .
	BTFSS	PORTB,PEJ	;  ,
	GOTO	VUBOR		;     .
	BCF	FLAG3,5		; .
	BCF	FLAG1,4		;  .
	INCF	REID,1		;  .
	MOVLW	.5		;4  .
	SUBWF	REID,0		; ,
	BTFSS	STATUS,2	;   .
	GOTO	VUBOR		;    .
	CLRF	REID		; .
	BCF	FLAG1,0		; .
	GOTO	VUBOR		;   .
;=============================
; 10.    .
;=============================
MC0
	MOVLW	.9	;
	SUBWF	MINL,0	;   9,
	BTFSC	STATUS,2; 
	CALL	MH	;    .
	CLRF	SECL	;   
	CLRF	SECH	;   .
	RETURN		;
;=================================================
; 11.   (  ).
;=================================================
KYPCY
	BTFSS	PORTB,PAZ	;  
	RETURN			;  .
	BTFSS	FLAG1,0		; ,
	RETURN			;  .
	BCF	FLAG3,5		; .
	BCF	FLAG1,5		;   .
	BTFSC	FLAG,0		;   ,
	GOTO	KYPCH		;    .
	BTFSC	FLAG,1		;   ,
	GOTO	KYPCK		;   .
	BTFSC	FLAG,7		;   ,
	GOTO	KYPCV		;    .
	RETURN			;
KYPCH
	MOVLW	.16		;  16.
	SUBWF	KYPC,0		;
	SKPC			;  16,
	GOTO	$+4		;
	MOVLW	.6		;   
	MOVWF	KYPC		; .
	RETURN			;
	INCF	KYPC,1		;   .
	MOVLW	.11		;  10.
	SUBWF	KYPC,0		;
	SKPC			;  10,
	RETURN			;
	MOVLW	.16		;  
	MOVWF	KYPC		;   .
	RETURN			;
KYPCK
	MOVLW	.10		; .
	SUBWF	KYPC,0		;
	SKPC			;    10,
	GOTO	$+9		;
	INCF	KYPC,1		;   .
	MOVLW	.12		;  11.
	SUBWF	KYPC,0		;
	SKPC			;    11,
	RETURN			;
	MOVLW	.6		;   
	MOVWF	KYPC		;.
	RETURN			;
	INCF	KYPC,1		;   .
	MOVLW	.8		;  7.
	SUBWF	KYPC,0		;
	SKPC			;    7,
	RETURN			;
	MOVLW	.10		;    
	MOVWF	KYPC		; .
	RETURN			;
KYPCV
	INCF	KYPC,1		;   .
	MOVLW	.17		;
	SUBWF	KYPC,0		;
	SKPC			;  16,
	RETURN			;
	MOVLW	.8		;
	MOVWF	KYPC		;     .
	RETURN			;
;=========================
; 12.   .
;=========================
AKTETE
	BCF	INTCON,7	; .
	BSF	STATUS,RP0	; 1.
	MOVWF	EEADR		; .
	BSF	EECON1,RD	;.
	MOVLW	.255		;   ,
	SUBWF	EEDATA,0	; -0.
	BTFSC	STATUS,Z	;
	CLRF	EEDATA		;, .. 255 .
	MOVFW	EEDATA		;   .
	BCF	STATUS,RP0	; 0.
	BSF	INTCON,7	; .
	RETURN			;.
;=========================================
; 13.  .
;=========================================
JEKINI
        MOVLW   3          ;.
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   3          ;.
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   3          ;
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   10         ;  
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   06         ;  .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   01         ; .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   28         ; : 4 ., 57, 2 .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   28         ;.
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   0C         ; ,  .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        GOTO    RASPR	; .
PAUSA
        MOVLW   .25
        MOVWF   ZAN
PAUS
        MOVLW   .255
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        DECFSZ  ZAN,1
        GOTO    PAUS
        RETURN
JEKOMI
        MOVWF   TEMP       ;    .
        ANDLW   B'11110000';    .
        MOVWF   PORTB      ;     "".
        CALL    STROB      ;.
        CALL    PAUSA      ;.
        MOVFW   TEMP
        SWAPF   TEMP,W     ;  .
        ANDLW   B'11110000';    .
        MOVWF   PORTB      ;   "".
        CALL    STROB      ;.
        CALL    PAUSA      ;.
        RETURN
;=========================================
; 14.   .
;=========================================
STROB
        BSF     PORTB,E    ; -.
	NOP
        BCF     PORTB,E    ; .
        RETURN             ;.
;===============================================
; 15.       .
;===============================================
JEKOM
        MOVWF   TEMP		;    .
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;     "".
        CALL    STROB		;.
        CALL    PUS		;.
        MOVFW   TEMP
        SWAPF   TEMP,W		;
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;   "".
        CALL    STROB		;.
PUS
        MOVLW   .255		; =1 .
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        RETURN
PUSO
        MOVLW   .10		; =40 .
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        RETURN
;=====================================
; 16.    .
;=====================================
JEDAT
        MOVWF   TEMP		;    .
        ANDLW   B'11110000'	;    .
        ADDLW   30		;   ASCII,   !
        MOVWF   PORTB		;     "".
        BSF     PORTB,RS	; R/S    .
        CALL    STROB		;.
        CALL    PUSO		;      .
        MOVFW   TEMP		;
        SWAPF   TEMP,0		;  .
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;     "".
        BSF     PORTB,RS	; R/S    .
        CALL    STROB		;.
        GOTO    PUSO		;.
;=======================================
; 17.  .
;=======================================
YC5
	BTFSS	FLAG,1	;   ,
	GOTO	YC5H	;
	BTFSC	FLAG,5	; 
	GOTO	$+3	;  
	BSF	FLAG,5	; .
	RETURN		;
	BCF	FLAG,5	;
	RETURN		;
YC5H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	HOUH,1	;   .
	MOVLW	.3	;3 .
	SUBWF	HOUH,0	;
	BTFSC	STATUS,0;  3,
	CLRF	HOUH	;.
	MOVFW	HOUH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	HOUL,0	; .
	MOVWF	HOU	;.
	RETURN		;
YC6
	BTFSS	FLAG,1	;   ,
	GOTO	YC6H	;
	INCF	KOPM,1	;  .
	MOVLW	.10	;
	SUBWF	KOPM,0	;  9.
	BTFSC	STATUS,0;
	CLRF	KOPM	;.
	RETURN		;
YC6H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	HOUL,1	;    .
	MOVLW	.10	;10 .
	SUBWF	HOUL,0	;
	BTFSC	STATUS,0;  10,
	CLRF	HOUL	;.
	MOVFW	HOUH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	HOUL,0	; .
	MOVWF	HOU	;.
	MOVLW	.24	;EC >  = 24,
	SUBWF	HOU,0	;
	SKPNC		;
	GOTO	$-8	;   .
	RETURN		;
YC7
	INCF	BUH1H,1	;      .
	MOVLW	.3	;3 .
	SUBWF	BUH1H,0	;
	BTFSC	STATUS,0;  3,
	CLRF	BUH1H	;.
	MOVFW	BUH1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH1L,0	; .
	MOVWF	BUH1	;.
	CALL	SAPIS	; .
	RETURN		;
YC8
	BTFSC	FLAG,0	;   ,
	GOTO	YC8H	;
	INCF	BUH1L,1	;      .
	MOVLW	.10	;10 .
	SUBWF	BUH1L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUH1L	;.
	MOVFW	BUH1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH1L,0	; .
	MOVWF	BUH1	;.
	MOVLW	.24	;
	SUBWF	BUH1,0	;
	SKPNC		;
	GOTO	$-8	;
	CALL	SAPIS	; .
	RETURN		;
YC8H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	MINH,1	;    .
	MOVLW	.6	;6 .
	SUBWF	MINH,0	;
	BTFSC	STATUS,0;  6,
	CLRF	MINH	;.
	MOVFW	MINH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	MINL,0	; .
	MOVWF	MIN	;.
	RETURN		;
YC9
	BTFSC	FLAG,0	;   ,
	GOTO	YC9H	;
	BTFSC	FLAG,1	;   K,
	GOTO	YC9K	;
	INCF	BUM1H,1	;      .
	MOVLW	.6	;6 .
	SUBWF	BUM1H,0	;
	BTFSC	STATUS,0;  6,
	CLRF	BUM1H	;.
	MOVFW	BUM1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM1L,0	; .
	MOVWF	BUM1	;.
	CALL	SAPIS	; .
	RETURN		;
YC9H
	INCF	MINL,1	;    .
	MOVLW	.10	;10 .
	SUBWF	MINL,0	;
	BTFSC	STATUS,0;  10,
	CLRF	MINL	;.
	MOVFW	MINH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	MINL,0	; .
	MOVWF	MIN	;.
	RETURN		;
YC9K
	INCF	KOPH,1	;   .
	MOVLW	.6	;
	SUBWF	KOPH,0	;  5.
	BTFSC	STATUS,0;
	CLRF	KOPH	;.
	MOVFW	KOPH	;  2 .
	CALL	DEBIN	;
	ADDWF	KOPL,0	;
	MOVWF	KOP	;
	RETURN		;
YC10
	BTFSC	FLAG,1	;   ,
	GOTO	YC10K	; .
	INCF	BUM1L,1	;      .
	MOVLW	.10	;10 .
	SUBWF	BUM1L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUM1L	;.
	MOVFW	BUM1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM1L,0	; .
	MOVWF	BUM1	;.
	CALL	SAPIS	; .
	RETURN		;
YC10K
	INCF	KOPL,1	;   .
	MOVLW	.10	;
	SUBWF	KOPL,0	;  9.
	BTFSC	STATUS,0;
	CLRF	KOPL	;.
	MOVFW	KOPH	;  2 .
	CALL	DEBIN	;
	ADDWF	KOPL,0	;
	MOVWF	KOP	;
	RETURN		;
YC12
	INCF	BUH2H,1	;      .
	MOVLW	.3	;3 .
	SUBWF	BUH2H,0	;
	BTFSC	STATUS,0;  3,
	CLRF	BUH2H	;.
	MOVFW	BUH2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH2L,0	; .
	MOVWF	BUH2	;.
	CALL	SAPIS	; .
	RETURN		;
YC13
	INCF	BUH2L,1	;    .
	MOVLW	.10	;10 .
	SUBWF	BUH2L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUH2L	;.
	MOVFW	BUH2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH2L,0	; .
	MOVWF	BUH2	;.
	MOVLW	.24	; 24  ,
	SUBWF	BUH2,0	;
	SKPNC		;
	GOTO	$-8	;  .
	CALL	SAPIS	; .
	RETURN		;
YC14
	INCF	BUM2H,1	;    .
	MOVLW	.6	;6 .
	SUBWF	BUM2H,0	;
	BTFSC	STATUS,0;  6,
	CLRF	BUM2H	;.
	MOVFW	BUM2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM2L,0	; .
	MOVWF	BUM2	;.
	CALL	SAPIS	; .
	RETURN		;
YC15
	BTFSS	FLAG,7	;   ,
	GOTO	YC15Z	;  .
	INCF	BUM2L,1	;    .
	MOVLW	.10	;10 .
	SUBWF	BUM2L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUM2L	;.
	MOVFW	BUM2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM2L,0	; .
	MOVWF	BUM2	;.
	CALL	SAPIS	; .
	RETURN		;
YC15Z
	INCF	ZVO,1	;  .
	MOVLW	.10	;
	SUBWF	ZVO,0	;  9.
	BTFSC	STATUS,0;
	CLRF	ZVO	;.
	RETURN		;
;============================================================
; 18.     .
;============================================================
JEKI
	BTFSC	FLAG1,1		;  ,
	GOTO	$+5		;   .
	BTFSS	FLAG1,0		;  ,
	GOTO	$+3		;   .
	BTFSS	FLAG,6		;    ,
	GOTO	JEKYC		; .
	MOVLW	0x0C		;  .
	CALL	JEKOM		; .
        MOVLW   02		;    .
        CALL    JEKOM		; .
	MOVLW	.8		;  .
	MOVWF	COUN		;
        MOVLW   R1		;   .
	MOVWF	FSR		;  .
	MOVFW	INDF		; .
        CALL    JEDAT		; .
	DECF	COUN,1		; .
	BTFSC	STATUS,2	;  0,
	GOTO	$+3		;    .
	INCF	FSR,1		;  
	GOTO	$-6		;.
        MOVLW   B'11000000'	;  ( 28).0x0C0 ;
        CALL    JEKOM		; .
	MOVLW	.8		; 
	MOVWF	COUN		;  .
	INCF	FSR,1		;
	MOVFW	INDF		;
        CALL    JEDAT		;
	DECF	COUN,1		;
	BTFSS	STATUS,2	;
	GOTO	$-5		;
	BCF	FLAG,6		;  - .
	RETURN			; .
;=======================================
; 19.     .
;=======================================
IND
	BTFSS	FLAG1,0	;     ,
	GOTO	INDO	;   .
	DECF	YPYK,0	;
	MOVWF	COUE	;
	CALL	CXUTKA	;
INDO
	BCF	FLAG,7	;   .
	BCF	FLAG1,0	;   .
        MOVFW   HOUH	; 
        MOVWF   R11	;  .
        MOVFW   HOUL	; .
        MOVWF   R12	;  .
        BTFSS   FLAG3,4	;  ,
        MOVLW	.240	;  .
        BTFSC   FLAG3,4	;   ,
	MOVLW	.253	;   .
	MOVWF	R13	;  .
        MOVFW   MINH	; .
        MOVWF   R14	;  .
        MOVFW   MINL	; .
        MOVWF   R15	;  .
	MOVLW	.116	;.
	MOVWF	R1	;
	MOVLW	.18	;.
	MOVWF	R2	;
	MOVLW	.254	;.
	MOVWF	R3	;
	MOVFW	IBUHH	;
	MOVWF	R5	;.
	MOVFW	IBUHL	;
	MOVWF	R6	;.
	MOVFW	IBUMH	;
	MOVWF	R7	;.
	MOVFW	IBUML	;
	MOVWF	R8	;.
	MOVLW	.240	;.
	MOVWF	R4	;
	MOVWF	R9	; 
	MOVWF	R10	; .
	MOVWF	R16	;
        RETURN		;
;=============================================
; 20.     .
;=============================================
INDYH
	BSF	FLAG1,0	; .
	BCF	FLAG1,1	;  .
	BTFSS	PORTA,PR;  ,
	CALL	MC0	;  .
	BTFSC	FLAG,0	;   ,
	GOTO	$+4	;   .
	BSF	FLAG,0	;  .
	MOVLW	.6	;  
	MOVWF	KYPC	; .
	MOVLW	.121	;.
	MOVWF	R1	;
	MOVLW	.19	;.
	MOVWF	R2	;
	MOVLW	.36	;.
	MOVWF	R3	;
	MOVLW	.254	;.
	MOVWF	R4	;
	MOVLW	.240	;.
	MOVWF	R5	;
	MOVWF	R11	;
	MOVWF	R15	;
	MOVFW	HOUH	; .
	MOVWF	R6	;  .
	MOVFW	HOUL	; .
	MOVWF	R7	;
	MOVLW	.253	;.
	MOVWF	R8	;
	MOVFW	MINH	; .
	MOVWF	R9	;
	MOVFW	MINL	; .
	MOVWF	R10	;
	MOVLW	.116	;.
	MOVWF	R12	;
	MOVLW	.18	;.
	MOVWF	R13	;
	MOVLW	.254	;.
	MOVWF	R14	;
	MOVFW	ZVO	;
	MOVWF	R16	;
	RETURN		;
;================================
; 21.   .
;================================
INIT
 BSF	STATUS,RP0	;   1.
 MOVLW	B'00000001'	;  , =4 ...01,
 MOVWF	OPTION_REG^80H	;  .
 MOVLW	B'10100000'	;  =   .
 MOVWF	INTCON		;
 MOVLW	B'00100000'	;RA0-RA4 -  , RA5 - .
 MOVWF	TRISA^80H
 MOVLW	B'00000000'	;RB0-RB7 -  .
 MOVWF	TRISB^80H
 CLRF	VRCON
 CLRF	PCON		;
 BCF	STATUS,RP0	;   0.
 CLRF	PORTB		; .
 CLRF	PORTA		;
 CLRF	FLAG		;  
 CLRF	FLAG1
 CLRF	FLAG3
 CLRF	T1CON		;   
 CLRF	T2CON
 CLRF	TMR0
 MOVLW	.7
 MOVWF	CMCON
 CLRF	KYPC
 CLRF	REID
 CLRF	SECL
 CLRF	SECH
 CLRF	MINL
 CLRF	MINH
 CLRF	HOUL
 CLRF	HOUH
 CLRF	SMC
 CLRF	COUZ
 CLRF	DES
 CLRF	COUE
 CLRF	KOP	; 
 CLRF	KOPM	;.
 CLRF	KOPH
 CLRF	KOPL
 CLRF	YPOKH
 CLRF	YPYK
 MOVLW	.1
 MOVWF	KYPC	;  .
 MOVWF	YPOKL
 MOVWF	ZVO	;
 CLRF	YPOK	;
 CLRF	IBUH	;
 CALL	COMP	;
 BSF	FLAG,3	;    .
 GOTO	JEKINI	;   LCD.
;===================================
; 22.   .
;===================================
INDYV
	BCF	FLAG,1	;  .
	BTFSC	FLAG,7	;  ,
	GOTO	PROSI	;   .
	BSF	FLAG,7	;  .
	MOVLW	.8	;  
	MOVWF	KYPC	; .
;=====================================================
; 23.       .
;=====================================================
PROSI
	MOVFW	YPOKH	;  .
	MOVWF	R1	;  .
	MOVFW	YPOKL	;
	MOVWF	R2	;
	MOVLW	.121	;.
	MOVWF	R3	;
	MOVLW	.32	;.
	MOVWF	R4	;
	MOVLW	.31	;.
	MOVWF	R5	;
	MOVLW	.27	;.
	MOVWF	R6	;
	MOVLW	.240	;.
	MOVWF	R7	;
	MOVFW	BUH1H	; .
	MOVWF	R8	;  .
	MOVFW	BUH1L	;.
	MOVWF	R9	;
	MOVFW	BUM1H	; .
	MOVWF	R10	;
	MOVFW	BUM1L	;.
	MOVWF	R11	;
	MOVLW	.47	;_.
	MOVWF	R12	;
	MOVFW	BUH2H	; .
	MOVWF	R13	;  .
	MOVFW	BUH2L	;.
	MOVWF	R14	;
	MOVFW	BUM2H	; .
	MOVWF	R15	;
	MOVFW	BUM2L	;.
	MOVWF	R16	;
	RETURN		;
;============================================
; 24.     .
;============================================
INDYK
	BSF	FLAG1,0	;.
	BCF	FLAG,0	;  .
	BCF	FLAG,7	;  .
	BTFSC	FLAG,1	;   ,
	GOTO	$+4	;   .
	BSF	FLAG,1	; .
	MOVLW	.6	;  
	MOVWF	KYPC	;.
	MOVLW	.27	;.
	MOVWF	R1	;
	MOVLW	.63	;.
	MOVWF	R2	;
	MOVLW	.64	;.
	MOVWF	R3	;
	MOVLW	.254	;.
	MOVWF	R4	;
	MOVLW	.240	;.
	MOVWF	R5	;
	MOVWF	R9	;
	MOVWF	R13	;
	MOVWF	R14	;
	MOVWF	R15	;
	MOVWF	R16	;
	BTFSC	FLAG,5	;   ,
	MOVLW	.253	;  .
	BTFSS	FLAG,5	;
	MOVLW	.251	; - .
	MOVWF	R6	;
	MOVFW	KOPM	; .
	MOVWF	R7	;
	MOVLW	.140	;"".
	MOVWF	R8	;
	MOVFW	KOPH	;  .
	MOVWF	R10	;
	MOVFW	KOPL	;  .
	MOVWF	R11	;
	MOVLW	.51	;"".
	MOVWF	R12	;
	RETURN		;
;=================================================
; 25.     2_10 .
;=================================================
BINDEC
	CLRF	BUH1L	;
	CLRF	BUH1H	;
	CLRF	BUM1L	;
	CLRF	BUM1H	;
	CLRF	BUH2L	;
	CLRF	BUH2H	;
	CLRF	BUM2L	;
	CLRF	BUM2H	;
	CLRF	DES	;
	MOVFW	BUH1	; 
	MOVWF	EDI	;.
	CALL	DEC	; .
	MOVWF	BUH1L	;   .
	MOVFW	DES	; 
	MOVWF	BUH1H	;   .
	CLRF	DES	; .
	MOVFW	BUM1	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUM1L	;
	MOVFW	DES	;
	MOVWF	BUM1H	;
	CLRF	DES	;
	MOVFW	BUH2	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUH2L	;
	MOVFW	DES	;
	MOVWF	BUH2H	;
	CLRF	DES	;
	MOVFW	BUM2	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUM2L	;
	MOVFW	DES	;
	MOVWF	BUM2H	;
	CLRF	DES	;
	RETURN		;
DEC
	MOVLW	.10	;
	BSF	STATUS,0;
	SUBWF	EDI,1	;
	BNC	$+3	;
	INCF	DES,1	;
	GOTO	$-5	;
	MOVLW	.10	;
	ADDWF	EDI,0	;
	RETURN		;
;===================================================================
; 26.       .
;===================================================================
CONST
	MOVWF  WTEMP	;   W 
	MOVFW  STATUS	;STATUS,
	MOVWF  STEMP	;
	MOVFW  FSR	;FSR.
	MOVWF  FTEMP	;
	CALL   S1	; 1   .
RECONST			;  .
	BCF    INTCON,2	;  (T0IF)   ( ).
	MOVFW  STEMP	; :
	MOVWF  STATUS	;STATUS,
	MOVFW  FTEMP	;
	MOVWF  FSR	;FSR,
	MOVFW  WTEMP	;W.
	RETFIE		;   .
;=========================================
; 27.  --.
;=========================================
S1
	INCF    SMC,1	;  250.
	MOVLW	.250	;
	SUBWF	SMC,0	;
	SKPZ		;
	RETURN
	CLRF	SMC	;
	BSF	FLAG,2	;  0,25 .
	BTFSC	FLAG3,3	; 
	GOTO	$+3	; 
	BSF	FLAG3,3	; .
	RETURN		;
	BCF	FLAG3,3	; /  2 (2 )
	BTFSC	FLAG3,4	; 
	GOTO	$+3	; 
	BSF	FLAG3,4	; .
	RETURN		;
	BCF	FLAG3,4	;
SZV
	BTFSS	FLAG,4	;   ,
	GOTO	SL	;  .
	INCF	COUZ,1	;+1.
	MOVFW	ZVO	;   .
	SUBWF	COUZ,0	;
	BTFSS	STATUS,2;
	GOTO	SL	;
	BCF	FLAG,4	;      
	CLRF	COUZ	;  .
SL
        MOVLW   .9	;  9 ,
        SUBWF   SECL,0	;
        BC      SH	;    .
        INCF    SECL,1	;  .
        RETURN
SH
        CLRF    SECL	; .
        MOVFW   SECH	;  
        ADDLW   -5H	; 5,
        BZ      ML	;  .
        INCF    SECH,1	;   .
        RETURN
ML
        CLRF    SECH	;  .
        BSF     FLAG1,7	;( ).
        MOVFW   MINL	;  
        ADDLW   -9H	; 9,
        BZ      MH	;  .
        INCF    MINL,1	;  .
	GOTO	DEBIL	;.
MH
        CLRF    MINL	;  .
	BTFSC	FLAG3,1	;
	GOTO	MHH	;
	TSTF	HOU	;
	BNZ	MHH	;
	TSTF	MINH	;
	BZ	PRAVKA	;
MHH
        MOVFW   MINH	;  
        ADDLW   -5H	; 5,
        BZ      HL	;  .
        INCF    MINH,1	;   .
	GOTO	DEBIL	;.
HL
        CLRF    MINH	;  .
	CALL	DEBIL	;.
        MOVFW   HOUH	;  
        ADDLW   -2H	; 2,
        BZ      HL4	;  .
        MOVFW   HOUL	;    9,
        ADDLW   -9H	;
        BZ      HH	;  .
        INCF    HOUL,1	;   .
	GOTO	DEBIH	;.
HL4
        MOVFW   HOUL	;  
        ADDLW   -3H	; 3,
        BZ      HH	; .
        INCF    HOUL,1	;  .
	GOTO	DEBIH	;.
HH
        CLRF    HOUL	;  .
        MOVFW   HOUH	;  
        ADDLW   -2H	; ,
        BZ      DL	; .
        INCF    HOUH,1	;   .
	GOTO	DEBIH	;.
DL
        CLRF    HOUH	;  .
	CLRF	HOU	;
	CLRF	MIN	;
	BCF	FLAG3,1	;  .
        RETURN
DEBIL
	MOVFW	MINH	;
	CALL	DEBIN	;  
	ADDWF	MINL,0	;
	MOVWF	MIN	;.
	RETURN		;
DEBIH
	MOVFW	HOUH	;
	CALL	DEBIN	;  
	ADDWF	HOUL,0	;
	MOVWF	HOU	;.
	RETURN		;
PRAVKA
	BTFSS	FLAG,5	;  ,
	GOTO	PRPLUS	;
	MOVFW	KOPM	;  10 .
	SUBLW	0x0A	;
	MOVWF	MINL	;
	MOVWF	MIN	;
	MOVFW	KOP	; 60 .
	SUBLW	0x3C	;
	MOVWF	SECL	;
	ADDLW	-0x0A	; 10.
	BTFSS	STATUS,0;    ,
	GOTO	$+4	;  .
	MOVWF	SECL	;     .
	INCF	SECH,1	; .
	GOTO	$-5	; .
	BSF	FLAG3,1	; .
	RETURN		;.
PRPLUS
	MOVFW	KOPM	; 
	MOVWF	MINL	;  .
	INCF	MINH,1	;
	CALL	DEBIL	;
	MOVFW	KOPL	;
	MOVWF	SECL	;
	MOVFW	KOPH	;
	MOVWF	SECH	;
	BSF	FLAG3,1	; .
	RETURN		;.
;================================
; 28.   .
;================================
SAPIS
	DECF	YPOK,0	;
	MOVWF	COUE	;
	MOVLW	BUH1	;   
	MOVWF	FSR	;   .
	MOVFW	COUE	;    .
	BSF	STATUS,5; 1.
	BCF	STATUS,6;
	MOVWF	EEADR	; .
        BCF     INTCON,7; .
	CALL	ZAPIS	; .
	INCF	FSR,1	;+1    .
	MOVLW	.32	;
	ADDWF	EEADR,1	;+32   .
	CALL	ZAPIS	; .
	INCF	FSR,1	;+1    .
	MOVLW	.32	;
	ADDWF	EEADR,1	;+32   .
	CALL	ZAPIS	; .
	INCF	FSR,1	;+1    .
	MOVLW	.32	;
	ADDWF	EEADR,1	;+32   .
	CALL	ZAPIS	; .
        BCF     STATUS,5; 0.
        BSF     INTCON,7; .
	RETURN		;.
ZAPIS
	MOVFW	INDF		;  
	MOVWF	EEDATA		;  .
        BSF     EECON1,WREN	; .
        MOVLW   55H		; 
        MOVWF   EECON2		;/
        MOVLW   0AAH		;/
        MOVWF   EECON2		;/
        BSF     EECON1,WR	;    .
        BTFSC   EECON1,WR	;    
        GOTO    $-1		;  .
        BCF     EECON1,WREN	; .
	RETURN			;.
;=================================================
; 29.      .
;=================================================
COMP
	BCF	FLAG1,7	;  1 .
	BTFSC	FLAG1,0	;  ,
	RETURN		;  .
	TSTF	IBUH	;   ,
	BNZ	$+4	;
	CLRF	YPYK	;     .
	BCF	FLAG,3	;
	GOTO	HAXALO	;
	BSF	FLAG,3	;
	MOVFW	IBUH	; .
	SUBWF	HOU,0	;
	SKPZ		;
	RETURN		;
	MOVFW	IBUM	;.
	SUBWF	MIN,0	;
	SKPZ		; ,
	RETURN		; .
	BTFSS	FLAG1,2	;    ,
	GOTO	HAXALO	;  .
	BCF	FLAG1,2	;   
	MOVFW	IBUH2	;  .
	MOVWF	IBUH	;
	MOVFW	IBUM2	;
	MOVWF	IBUM	;
	MOVFW	IBUH2H	;
	MOVWF	IBUHH	;
	MOVFW	IBUH2L	;
	MOVWF	IBUHL	;
	MOVFW	IBUM2H	;
	MOVWF	IBUMH	;
	MOVFW	IBUM2L	;
	MOVWF	IBUML	;
	GOTO	ZWONOK	;.
HAXALO
	BSF	FLAG1,2	; .
	MOVFW	YPYK	;
	MOVWF	COUE	; .
	INCF	YPYK,1	;  .
	CALL	CXUTKA	;  
	MOVFW	BUH1	;  .
	MOVWF	IBUH	;  
	MOVFW	BUM1	;.
	MOVWF	IBUM	;
	MOVFW	BUH1H	;
	MOVWF	IBUHH	;
	MOVFW	BUH1L	;
	MOVWF	IBUHL	;
	MOVFW	BUM1H	;
	MOVWF	IBUMH	;
	MOVFW	BUM1L	;
	MOVWF	IBUML	;
	MOVFW	BUH2	;   
	MOVWF	IBUH2	;  
	MOVFW	BUM2	;.
	MOVWF	IBUM2	;
	MOVFW	BUH2H	;
	MOVWF	IBUH2H	;
	MOVFW	BUH2L	;
	MOVWF	IBUH2L	;
	MOVFW	BUM2H	;
	MOVWF	IBUM2H	;
	MOVFW	BUM2L	;
	MOVWF	IBUM2L	;
	BTFSS	FLAG,3	;
	RETURN		;
ZWONOK
	CALL	JEKI	;     .
	TSTF	ZVO	;   ,
	SKPNZ		;
	RETURN		;   .
	BSF	PORTA,0	; .
	BSF	FLAG,4	; .
	BTFSC	FLAG,4	; 
	GOTO	$-1	; .
	BCF	PORTA,0	; .
	RETURN		;.
;==================================================
; 30.    .
;==================================================
	ORG     0x2100
; BUH1
	DATA	0x08, 0x08, 0x0A, 0x0B, 0x0C, 0x0C, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
; BUM1
	DATA	0x00, 0x37, 0x00, 0x05, 0x00, 0x37, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
; BUH2
	DATA	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
; BUM2
	DATA	0x2D, 0x28, 0x2D, 0x32, 0x2D, 0x28, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	DATA	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
;============================================================================
	END
;============================================================================
