; 
;   LCD.
; 7 , 32  /
; .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = TAIM7.ASM
; : 22-12-04.
;   : MPLAB IDE, : 5.70.40.
;
            #INCLUDE P16F628.INC
            __CONFIG 3F09H
;==================================================================
;    4,096 .
;     4,  
;  TMR0 (256), ,  4    : 250, 2, 2
;    1  (444250256=4096000).
;==================================================================
; RA0-RA4 - 1-5 , RB0, RB1 - 6, 7 .
; RA5 -  : .
; RB2 - R/S - /, RB3 - E - ,
; RB4-RB7 - DB4-DB7-.  -.
; RB4-RB6 -  : , , ,
;============================================
;  .
;============================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  9AH  ; .
EEADR    EQU  9BH  ; .
EECON1   EQU  9CH  ; -
EECON2   EQU  9DH  ;.
;============================================
;   .
;============================================
R1	EQU	50H	;
R2	EQU	51H	;
R3	EQU	52H	;
R4	EQU	53H	;
R5	EQU	54H	;
R6	EQU	55H	;
R7	EQU	56H	;
R8	EQU	57H	;
R9	EQU	58H	;
R10	EQU	59H	;
R11	EQU	5AH	;
R12	EQU	5BH	;
R13	EQU	5CH	;
R14	EQU	5DH	;
R15	EQU	5EH	;
R16	EQU	5FH	;
BUH2	EQU	20H	;   .
BUM2	EQU	21H	;- .
BUH2L	EQU	22H	;  .
BUH2H	EQU	23H	;  .
BUM2L	EQU	24H	;  .
BUM2H	EQU	25H	;  .
COUE	EQU	26H	;    .
SMC	EQU	27H	; .
;============================================
;     FLAG.
;============================================
FLAG	EQU	28H   
;
;     0->  .
;     1->  .
;     2-> 1   .
;     3->  .
;     4-> .
;     5->  , 1-.
;     6-> /.
;     7->  .
;=====================================
;    .
;=====================================
SECL	EQU	2AH	; .  
SECH	EQU	2BH	; .
MINL	EQU	2CH	; .
MINH	EQU	2DH	; .
HOUL	EQU	2EH	; .
HOUH	EQU	2FH	; .
;==================================
; : , .
;==================================
VUX	EQU	30H	;  .
VUXY	EQU	31H	;  .
TEMP1	EQU	32H	;  / .
COUP	EQU	33H	;   .
KOP0	EQU	34H	; .
KOP1	EQU	35H	; .
W_TEMP	EQU	36H	;  W  .
STATUS_TEMP	EQU	37H  ;  STATUS  .
BUH1L	EQU	38H	;  .
BUH1H	EQU	39H	;  .
TEMP	EQU	3AH	;  / .
FSR_TEMP	EQU	3BH  ;  FSR.
MIN	EQU	3CH	;,  .
HOU	EQU	3DH	;,  .
BUM1	EQU	3EH	;     (+).
BUH1	EQU	3FH	;     (+).
BUM1L	EQU	40H	;   .
BUM1H	EQU	41H	;   .
EDI	EQU	42H	;  .
DES	EQU	43H	;  .
COUN	EQU	44H	;   .
ZAN	EQU	45H	;CT .
KYPC	EQU	46H	;.
REID	EQU	47H	; .
KOP2	EQU	48H	; .
KOP	EQU	49H	;  .
ZACON	EQU	4AH	;   /.
BUZAH1	EQU	4BH	;   .  .
BUZAH2	EQU	4CH	; .
BUZAM1	EQU	4DH	; .
BUZAM2	EQU	4EH	; .
;============================================
;     FLAG1.
;============================================
FLAG1	EQU	4FH	;
;
;	0-> 1= .
;	    0=.
;	1-> .
;	2-> /   .
;	3->   .
;	4->   .
;	5->   .
;	6->  / .
;	7->    .
;============================================
;     FLAG3.
;============================================
FLAG3	EQU	29H
;
;	0-> 1-      .
;	1->  .
;	3->   2.
;	4->   2,   .
;	5-> 1-   ( ).
;========================================
RS	EQU	2	;/.
E	EQU	3	;.
YCT	EQU	6	;.
PAZ	EQU	5	;.
PEJ	EQU	4	;.
PR	EQU	5	;/. 
;======================
; 1. .
;======================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;=======================================
; 2.   .
;=======================================
VUBOR
	BTFSS	PORTB,PEJ	;  ,
	BSF	FLAG3,5		;
	BTFSS	PORTB,PAZ	;  ,
	BSF	FLAG3,5		;
	BTFSS	PORTB,YCT	;  ,
	BSF	FLAG3,5		; .
	MOVFW	REID		;  .
	ADDWF	PC,1		; . 
	GOTO	IND		;    .
	GOTO	INDPR		;  .
	GOTO	INDYH		; .
	GOTO	INDYK		; .
	GOTO	INDYV		; .
;=======================================
; 3.   .
;=======================================
YCTA
	BTFSS	PORTB,YCT	;  ,
	RETURN			;  .
	BCF	FLAG3,5		; .
	BCF	FLAG1,3		;  .
	MOVFW	KYPC		; 
	ADDWF	PC,1		;  .
	RETURN			;   .
	GOTO	YC0		;
	GOTO	YC1		;
	GOTO	YC2		;
	RETURN			;   .
	GOTO	YC4		;
	GOTO	YC5		;
	GOTO	YC6		;
	GOTO	YC7		;
	GOTO	YC8		;
	GOTO	YC9		;
	GOTO	YC10		;
	GOTO	YC11		;
	GOTO	YC12		;
	GOTO	YC13		;
	GOTO	YC14		;
	GOTO	YC15		;
;========================================================
; 4.      .
;========================================================
DEBIN
	ADDWF	PC,1	;
	RETLW	.0
	RETLW	.10
	RETLW	.20
	RETLW	.30
	RETLW	.40
	RETLW	.50
	RETLW	.60
	RETLW	.70
	RETLW	.80
	RETLW	.90
DEBIC
	ADDWF	PC,1	;
	RETLW	.0
	RETLW	.100
	RETLW	.200
;==========================================
; 5.  / .
;==========================================
PCUX
        MOVFW   VUX      ;  
        ADDWF   PC,1     ;    .
	GOTO	CPLUS	;
        GOTO    RA0      ;
        GOTO    RA1      ;
        GOTO    RA2      ;
        GOTO    RA3      ;
        GOTO    RA4      ;
        GOTO    RB0      ;
        GOTO    RB1      ;
;=========================================
; 6.  ().
;=========================================
RASPR
	BTFSS	FLAG,2		;  
	GOTO	$-1		; 1/4 .
	BCF	FLAG,2		; .
	BSF	STATUS,5	;   1.
	MOVLW	B'01110000'	;RB4-RB6 -  .
	MOVWF	TRISB^80H	;
	BCF	STATUS,5	;   0.
	CALL	KHOP		; .
	BSF	STATUS,5	;   1.
	MOVLW	B'00000000'	;RB0-RB7 -  .
	MOVWF	TRISB^80H	;
	BCF	STATUS,5	;   0.
	BTFSS	FLAG1,7		;  -  .
	CALL	POUCK		;   .
	BTFSS	FLAG3,5		;    .
	GOTO	JEKI		;.
	GOTO	RASPR		;.
;=========================================
; 7.  .
;=========================================
JEKYC
	MOVLW	.14	;  .
	CALL    JEKOM	; .
	CALL	JEKYK	;   .
	CALL    JEKOM	; .
	BSF	FLAG,6	;  - .
	GOTO	RASPR	;  .
JEKYK
	MOVFW	KYPC	;   .
	ADDWF	PC,1	;
	RETLW	0x0C	;   (  ).
	RETLW	0x80	;   
	RETLW	0x81	;
	RETLW	0x82	;
	RETLW	0x83	;
	RETLW	0x84	;
	RETLW	0x85	;
	RETLW	0x86	;
	RETLW	0x87	;
	RETLW	0xC0	;  ( 28) 0x0C0;
	RETLW	0xC1	;
	RETLW	0xC2	;
	RETLW	0xC3	;
	RETLW	0xC4	;
	RETLW	0xC5	;
	RETLW	0xC6	;
	RETLW	0xC7	;
;=================================================
; 8.      .
;=================================================
INDPR
	MOVLW	.1	;   .
	MOVWF	KYPC	;
	BTFSS	PORTA,PR;   ,
	BSF	FLAG1,6	; .
	BTFSS	PORTA,PR;   ,
	GOTO	PROSI	; .
	BTFSS	FLAG1,6	;  ,
	GOTO	PROSI	;
	BCF	FLAG1,6	; .
	BTFSC	FLAG,3	;   ,
	GOTO	PLUS	;   .
	BSF	FLAG1,1	; .
	CLRF	COUE	;  .
CXUTKA
        MOVFW   COUE	;  
	CALL	AKTETE	;   .
	MOVWF	TEMP	;   .
	SWAPF	TEMP,0	;  
	ANDLW	B'00001111'; 
	MOVWF	VUX	;  .
	BCF	STATUS,0; 
	RRF	VUX,1	; .
	TSTF	VUX	;   ,
	BZ	PLUS	;  ,    . .
	MOVFW	VUX	;   
	SUBWF	VUXY,0	; .
	BTFSS	STATUS,2;    ,
	GOTO	PLUS	;     .
	MOVFW	COUE	;   ,
	MOVWF	ZACON	;     .
        MOVLW   B'00011111';  
        ANDWF   TEMP,0	;
	MOVWF	BUH1	;  .
	MOVLW	.64	;  .
	ADDWF	COUE,0	;
	CALL	AKTETE	;  .
	MOVWF	BUM1	;   .
	BTFSC	BUM1,7	;    ,
	BSF	FLAG3,0	;    .
	BTFSS	BUM1,7	;
	BCF	FLAG3,0	;   .
        MOVLW   B'00111111'; 
        ANDWF   BUM1,1   ;  .
	INCF	COUE,0	;    .
	CALL	AKTETE	; .
	MOVWF	BUH2	;   .
        MOVLW   B'00011111'; 
        ANDWF   BUH2,1	;   .
	MOVLW	.65	;  .
	ADDWF	COUE,0	;
	CALL	AKTETE	;  .
	MOVWF	BUM2	;    .
	BSF	FLAG,3	; .
	CALL	BINDEC	;  2_10 .
	GOTO	PROSI	;.
PLUS
	MOVLW	.2	;    2.
	ADDWF	COUE,1	;
	MOVLW	.64	;  
	SUBWF	COUE,0	;  64 (0-63).
	BTFSS	STATUS,2;
	GOTO	CXUTKA	; .
	BTFSS	FLAG,3	;     ,
	GOTO	PYCTO	;      .
	BCF	FLAG,3	;  .
	CALL	BINDEC	;  2_10 .
	GOTO	PROSI	;.
PYCTO
	MOVLW	.253	;
	MOVWF	VUXY	; 
	MOVWF	BUH1H	;.
	MOVWF	BUH1L	;
	MOVWF	BUM1H	;
	MOVWF	BUM1L	;
	MOVWF	BUH2H	;
	MOVWF	BUH2L	;
	MOVWF	BUM2H	;
	MOVWF	BUM2L	;
	BCF	FLAG3,0	; .
	GOTO	PROSI	;
;======================================
; 9.    .
;======================================
KHOP
	BTFSC	FLAG1,3		;    ,
	CALL	YCTA		;    .
	BTFSS	PORTB,YCT	;  "" ,
	BSF	FLAG1,3		; .
	BTFSC	FLAG1,5		;    ,
	CALL	KYPCY		;    .
	CLRF	PCLATH		;
	BTFSS	PORTB,PAZ	;  "" ,
	BSF	FLAG1,5		; .
	BTFSC	FLAG1,4		;   ,
	GOTO	$+4		;  .
	BTFSS	PORTB,PEJ	;  "" ,
	BSF	FLAG1,4		; .
	GOTO	VUBOR		;     .
	BTFSS	PORTB,PEJ	;  ,
	GOTO	VUBOR		;     .
	BCF	FLAG3,5		; .
	BCF	FLAG1,4		;  .
	INCF	REID,1		;  .
	MOVLW	.5		;4  .
	SUBWF	REID,0		; ,
	BTFSS	STATUS,2	;   .
	GOTO	VUBOR		;    .
	CLRF	REID		; .
	BCF	FLAG1,0		; .
	GOTO	VUBOR		;   .
;=============================
; 10.    .
;=============================
MC0
	MOVLW	.9	;
	SUBWF	MINL,0	;   9,
	BTFSC	STATUS,2; 
	CALL	MH	;    .
	CLRF	SECL	;   
	CLRF	SECH	;   .
	RETURN		;
;=================================================
; 11.   (  ).
;=================================================
KYPCY
	BTFSS	PORTB,PAZ	;  
	RETURN			;  .
	BTFSS	FLAG1,0		; ,
	RETURN			;  .
	BCF	FLAG3,5		; .
	BCF	FLAG1,5		;   .
	BTFSC	FLAG,0		;   ,
	GOTO	KYPCH		;    .
	BTFSC	FLAG,1		;   ,
	GOTO	KYPCK		;   .
	BTFSC	FLAG,7		;   ,
	GOTO	KYPCV		;    .
	RETURN			;
KYPCH
	INCF	KYPC,1		;   .
	MOVLW	.14		;  13.
	SUBWF	KYPC,0		;
	SKPC			;  13,
	RETURN			;
	MOVLW	.9		;
	MOVWF	KYPC		;     .
	RETURN			;
KYPCK
	INCF	KYPC,1		;   .
	MOVLW	.13		;  12.
	SUBWF	KYPC,0		;
	SKPC			;  12,
	RETURN			;
	MOVLW	.9		;
	MOVWF	KYPC		;     .
	RETURN			;
KYPCV
	INCF	KYPC,1		;   .
	MOVLW	.17		;
	SUBWF	KYPC,0		;
	SKPC			;  16,
	GOTO	KYPCVY		;
	MOVLW	.1		;
	MOVWF	KYPC		;     .
	RETURN			;
KYPCVY
	MOVLW	HIGH 100	;
	MOVWF	PCLATH		;
	CALL	KYPCV0		;  ,
	MOVWF	KYPC		;    "" .
	RETURN			;
KYPCV0
	MOVFW	KYPC		;  
	ADDWF	PC,1		;  .
	RETLW	.1		;
	RETLW	.1		;
	RETLW	.2
	RETLW	.5
	RETLW	.5
	RETLW	.5
	RETLW	.6
	RETLW	.7
	RETLW	.8
	RETLW	.13
	RETLW	.13
	RETLW	.13
	RETLW	.13
	RETLW	.13
	RETLW	.14
	RETLW	.15
	RETLW	.16
;========================================================
; 12.  .
;========================================================
RA0
	BTFSS   FLAG1,2	;  . 1,
	GOTO    $+3	;
	BSF     PORTA,0	;  .
	GOTO    CPLUS	;   .
	BCF     PORTA,0	;  ,   .
	GOTO    CPLUS	;   .
RA1
	BTFSS	FLAG1,2	;  
	GOTO    $+3	; .
	BSF     PORTA,1	;  
	GOTO    CPLUS	;
	BCF     PORTA,1	;
	GOTO    CPLUS	;
RA2
	BTFSS   FLAG1,2	;
	GOTO    $+3	;
	BSF     PORTA,2	;
	GOTO    CPLUS	;
	BCF     PORTA,2	;
	GOTO    CPLUS	;
RA3
	BTFSS   FLAG1,2	;
	GOTO    $+3	;
	BSF     PORTA,3	;
	GOTO    CPLUS	;
	BCF     PORTA,3	;
	GOTO    CPLUS	;
RA4
	BTFSS   FLAG1,2	;
	GOTO    $+3	;
	BSF     PORTA,4	;
	GOTO    CPLUS	;
	BCF     PORTA,4	;
	GOTO    CPLUS	;
RB0
	BTFSS   FLAG1,2	;
	GOTO    $+3	;
	BSF     PORTB,0	;
	GOTO    CPLUS	;
	BCF     PORTB,0	;
	GOTO    CPLUS	;
RB1
	BTFSS   FLAG1,2	;
	GOTO    $+3	;
	BSF     PORTB,1	;
	GOTO    CPLUS	;
	BCF     PORTB,1	;
	GOTO    CPLUS	;
;=========================
; 13.   .
;=========================
AKTETE
	BCF	INTCON,7	; .
	BSF	STATUS,RP0	; 1.
	MOVWF	EEADR		; .
	BSF	EECON1,RD	;.
	MOVLW	.255		;   ,
	SUBWF	EEDATA,0	; -0.
	BTFSC	STATUS,Z	;
	CLRF	EEDATA		;, .. 255 .
	MOVFW	EEDATA		;   .
	BCF	STATUS,RP0	; 0.
	BSF	INTCON,7	; .
	RETURN			;.
;=========================================
; 14.  .
;=========================================
JEKINI
        MOVLW   3          ;.
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   3          ;.
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   3          ;
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   10         ;  
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   06         ;  .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   01         ; .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   28         ; : 4 ., 57, 2 .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        MOVLW   28         ;.
        CALL    JEKOMI     ;
        CALL    STROB      ;.
        MOVLW   0C         ; ,  .
        CALL    JEKOMI     ; .
        CALL    STROB      ;.
        GOTO    JEKI       ; .
PAUSA
        MOVLW   .25
        MOVWF   ZAN
PAUS
        MOVLW   .255
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        DECFSZ  ZAN,1
        GOTO    PAUS
        RETURN
JEKOMI
        MOVWF   TEMP       ;    .
        ANDLW   B'11110000';    .
        MOVWF   PORTB      ;     "".
        CALL    STROB      ;.
        CALL    PAUSA      ;.
        MOVFW   TEMP
        SWAPF   TEMP,W     ;  .
        ANDLW   B'11110000';    .
        MOVWF   PORTB      ;   "".
        CALL    STROB      ;.
        CALL    PAUSA      ;.
        RETURN
;=========================================
; 15.   .
;=========================================
STROB
        BSF     PORTB,E    ; -.
	NOP
        BCF     PORTB,E    ; .
        RETURN             ;.
;===============================================
; 16.       .
;===============================================
JEKOM
        MOVWF   TEMP		;    .
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;     "".
        CALL    STROB		;.
        CALL    PUS		;.
        MOVFW   TEMP
        SWAPF   TEMP,W		;
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;   "".
        CALL    STROB		;.
PUS
        MOVLW   .255		;1 .
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        RETURN
PUSO
        MOVLW   .10		;40 .
        ADDLW   -1
        BTFSS   STATUS,2
        GOTO    $-2
        RETURN
;=====================================
; 17.    .
;=====================================
JEDAT
        MOVWF   TEMP		;    .
        ANDLW   B'11110000'	;    .
        ADDLW   30		;   ASCII,   !
        MOVWF   PORTB		;     "".
        BSF     PORTB,RS	; R/S    .
        CALL    STROB		;.
        CALL    PUSO		;      .
        MOVFW   TEMP		;
        SWAPF   TEMP,0		;  .
        ANDLW   B'11110000'	;    .
        MOVWF   PORTB		;     "".
        BSF     PORTB,RS	; R/S    .
        CALL    STROB		;.
        GOTO    PUSO		;.
;=======================================
; 18.  .
;=======================================
YC0
	BCF	FLAG1,2	;  .
	INCF	VUXY,1	; .
	MOVLW	.8	;8  .
	SUBWF	VUXY,0	;
	BTFSS	STATUS,0;  8,
	RETURN		;
	CLRF	VUXY	; .
	RETURN		;
YC1
YC2
	BTFSC	FLAG3,0	; 
	GOTO	$+3	; 
	BSF	FLAG3,0	; .
	GOTO	$+2	;
	BCF	FLAG3,0	;
	GOTO	ZAPIS	; .
YC3
	RETURN		;
YC4
	INCF	BUH1H,1	;     .
	MOVLW	.3	;3 .
	SUBWF	BUH1H,0	;
	BTFSC	STATUS,0;  3,
	CLRF	BUH1H	;.
	MOVFW	BUH1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH1L,0	; .
	MOVWF	BUH1	;.
	RETURN		;
YC5
	INCF	BUH1L,1	;     .
	MOVLW	.10	;10 .
	SUBWF	BUH1L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUH1L	;.
	MOVFW	BUH1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH1L,0	; .
	MOVWF	BUH1	;.
	MOVLW	.24	;
	SUBWF	BUH1,0	;
	SKPNC		;
	GOTO	$-8	;
	RETURN		;
YC6
	INCF	BUM1H,1	;     .
	MOVLW	.6	;6 .
	SUBWF	BUM1H,0	;
	BTFSC	STATUS,0;  6,
	CLRF	BUM1H	;.
	MOVFW	BUM1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM1L,0	; .
	MOVWF	BUM1	;.
	RETURN		;
YC7
	INCF	BUM1L,1	;     .
	MOVLW	.10	;10 .
	SUBWF	BUM1L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUM1L	;.
	MOVFW	BUM1H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM1L,0	; .
	MOVWF	BUM1	;.
	RETURN		;
YC8
	BTFSS	FLAG,1	;   ,
	GOTO	YC8H	;
	BTFSC	FLAG,5	; 
	GOTO	$+3	;  
	BSF	FLAG,5	; .
	RETURN		;
	BCF	FLAG,5	;
	RETURN		;
YC8H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	HOUH,1	;   .
	MOVLW	.3	;3 .
	SUBWF	HOUH,0	;
	BTFSC	STATUS,0;  3,
	CLRF	HOUH	;.
	MOVFW	HOUH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	HOUL,0	; .
	MOVWF	HOU	;.
	RETURN		;
YC9
	BTFSS	FLAG,1	;   ,
	GOTO	YC9H	;
	INCF	KOP0,1	;  .
	MOVLW	.3	;
	SUBWF	KOP0,0	;  3.
	BTFSC	STATUS,0;
	CLRF	KOP0	;.
	GOTO	DEBIK	;.
YC9H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	HOUL,1	;    .
	MOVLW	.10	;10 .
	SUBWF	HOUL,0	;
	BTFSC	STATUS,0;  10,
	CLRF	HOUL	;.
	MOVFW	HOUH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	HOUL,0	; .
	MOVWF	HOU	;.
	MOVLW	.24	; >  = 24,
	SUBWF	HOU,0	;
	SKPNC		;
	GOTO	$-8	;   .
	RETURN		;
YC10
	BTFSS	FLAG,1	;   ,
	RETURN		;
	INCF	KOP1,1	;  .
	MOVLW	.10	;
	SUBWF	KOP1,0	;  9.
	BTFSC	STATUS,0;
	CLRF	KOP1	;.
	GOTO	DEBIK	;  2 .
YC11
	BTFSS	FLAG,1	;   ,
	GOTO	YC11H	;
	INCF	KOP2,1	;  .
	MOVLW	.10	;
	SUBWF	KOP2,0	;  9.
	BTFSC	STATUS,0;
	CLRF	KOP2	;.
	GOTO	DEBIK	;  2 .
YC11H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	MINH,1	;    .
	MOVLW	.6	;6 .
	SUBWF	MINH,0	;
	BTFSC	STATUS,0;  6,
	CLRF	MINH	;.
	MOVFW	MINH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	MINL,0	; .
	MOVWF	MIN	;.
	RETURN		;
YC12
	BTFSC	FLAG,0	;   ,
	GOTO	YC12H	;  .
	INCF	BUH2H,1	;     .
	MOVLW	.3	;3 .
	SUBWF	BUH2H,0	;
	BTFSC	STATUS,0;  3,
	CLRF	BUH2H	;.
	MOVFW	BUH2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH2L,0	; .
	MOVWF	BUH2	;.
	RETURN		;
YC12H
	BTFSS	FLAG,0	;   ,
	RETURN		; .
	INCF	MINL,1	;    .
	MOVLW	.10	;10 .
	SUBWF	MINL,0	;
	BTFSC	STATUS,0;  10,
	CLRF	MINL	;.
	MOVFW	MINH	;   
	CALL	DEBIN	; 2_10 
	ADDWF	MINL,0	; .
	MOVWF	MIN	;.
	RETURN		;
YC13
	INCF	BUH2L,1	;     .
	MOVLW	.10	;10 .
	SUBWF	BUH2L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUH2L	;.
	MOVFW	BUH2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUH2L,0	; .
	MOVWF	BUH2	;.
	MOVLW	.24	; 24  ,
	SUBWF	BUH2,0	;
	SKPNC		;
	GOTO	$-8	;  .
	RETURN		;
YC14
	INCF	BUM2H,1	;     .
	MOVLW	.6	;6 .
	SUBWF	BUM2H,0	;
	BTFSC	STATUS,0;  6,
	CLRF	BUM2H	;.
	MOVFW	BUM2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM2L,0	; .
	MOVWF	BUM2	;.
	RETURN		;
YC15
	INCF	BUM2L,1	;     .
	MOVLW	.10	;10 .
	SUBWF	BUM2L,0	;
	BTFSC	STATUS,0;  10,
	CLRF	BUM2L	;.
	MOVFW	BUM2H	;   
	CALL	DEBIN	; 2_10 
	ADDWF	BUM2L,0	; .
	MOVWF	BUM2	;.
	RETURN		;
DEBIK
	MOVFW	KOP0	; ,
	CALL	DEBIC	;
	MOVWF	TEMP	;
	MOVFW	KOP1	;
	CALL	DEBIN	;
	ADDWF	TEMP,0	;
	BTFSC	STATUS,0;
	GOTO	$+9	;
	ADDWF	KOP2,0	; 
	MOVWF	KOP	;  .
	SKPNC		;  256,
	GOTO	$+5	; .
	MOVLW	.250	;    250,
	SUBWF	KOP,0	;
	SKPC		; .
	RETURN		;
	CLRF	KOP0	; .
	CLRF	KOP1	;
	CLRF	KOP2	;
	CLRF	KOP	;
	RETURN		;
;============================================================
; 19.     .
;============================================================
JEKI
	BTFSS	FLAG1,0		;  ,
	GOTO	$+3		;   .
	BTFSS	FLAG,6		;    ,
	GOTO	JEKYC		; .
	MOVLW	0x0C		;  .
	CALL	JEKOM		; .
        MOVLW   02		;    .
        CALL    JEKOM		; .
	MOVLW	.8		;  .
	MOVWF	COUN		;
        MOVLW   R1		;   .
	MOVWF	FSR		;  .
	MOVFW	INDF		; .
        CALL    JEDAT		; .
	DECF	COUN,1		; .
	BTFSC	STATUS,2	;  0,
	GOTO	$+3		;    .
	INCF	FSR,1		;  
	GOTO	$-6		;.
        MOVLW   B'11000000'	;  ( 28).0x0C0 ;
        CALL    JEKOM		; .
	MOVLW	.8		; 
	MOVWF	COUN		;  .
	INCF	FSR,1		;
	MOVFW	INDF		;
        CALL    JEDAT		;
	DECF	COUN,1		;
	BTFSS	STATUS,2	;
	GOTO	$-5		;
	BCF	FLAG,6		;  - .
	GOTO	RASPR		; .
;=======================================
; 20.     .
;=======================================
IND
	BCF	FLAG1,0	;    .
	BCF	FLAG,7	;
        MOVFW   HOUH	; 
        MOVWF   R9	;  .
        MOVFW   HOUL	; .
        MOVWF   R10	;  .
        BTFSS   FLAG3,4	;  ,
        MOVLW	.240	;  .
        BTFSC   FLAG3,4	;   ,
	MOVLW	.253	;   .
	MOVWF	R11	;  .
        MOVFW   MINH	; .
        MOVWF   R12	;  .
        MOVFW   MINL	; .
        MOVWF   R13	;  .
	BTFSS	PORTA,0	;    ,
	MOVLW	.240	;   
	BTFSC	PORTA,0	;
	MOVLW	.1	;  .
	MOVWF	R1	;1.
	BTFSS	PORTA,1	;
	MOVLW	.240	;.
	BTFSC	PORTA,1	;
	MOVLW	.2	;
	MOVWF	R2	;2.
	BTFSS	PORTA,2	;
	MOVLW	.240	;.
	BTFSC	PORTA,2	;
	MOVLW	.3	;
	MOVWF	R3	;3.
	BTFSS	PORTA,3	;
	MOVLW	.240	;.
	BTFSC	PORTA,3	;
	MOVLW	.4	;
	MOVWF	R4	;4.
	BTFSS	PORTA,4	;
	MOVLW	.240	;.
	BTFSC	PORTA,4	;
	MOVLW	.5	;
	MOVWF	R5	;5.
	BTFSS	PORTB,0	;
	MOVLW	.240	;.
	BTFSC	PORTB,0	;
	MOVLW	.6	;
	MOVWF	R6	;6.
	BTFSS	PORTB,1	;
	MOVLW	.240	;.
	BTFSC	PORTB,1	;
	MOVLW	.7	;
	MOVWF	R7	;6.
	MOVLW	.240	;.
	MOVWF	R8	; 
	MOVWF	R14	; .
	MOVWF	R15	;
	MOVWF	R16	;
        RETURN		;
;=============================================
; 21.   .
;=============================================
INDYH
	BSF	FLAG1,0	; .
	BCF	FLAG1,1	;  .
	BTFSS	PORTA,PR;  ,
	CALL	MC0	;   .
	BTFSC	FLAG,0	;   ,
	GOTO	$+4	;   .
	BSF	FLAG,0	;  .
	MOVLW	.9	;  
	MOVWF	KYPC	; .
	MOVLW	.121	;.
	MOVWF	R1	;
	MOVLW	.19	;.
	MOVWF	R2	;
	MOVLW	.36	;.
	MOVWF	R3	;
	MOVLW	.254	;.
	MOVWF	R4	;
	MOVLW	.240	;.
	MOVWF	R5	;
	MOVWF	R6	;
	MOVWF	R7	;
	MOVWF	R8	;
	MOVWF	R14	;
	MOVWF	R15	;
	MOVWF	R16	;
	MOVFW	HOUH	; .
	MOVWF	R9	;  .
	MOVFW	HOUL	; .
	MOVWF	R10	;
	MOVLW	.253	;.
	MOVWF	R11	;
	MOVFW	MINH	; .
	MOVWF	R12	;
	MOVFW	MINL	; .
	MOVWF	R13	;
	RETURN		;
;=====================
; 22.   .
;=====================
INIT
 BSF	STATUS,RP0	;   1.
 MOVLW	B'00000001'	;  , =4 ...01,
 MOVWF	OPTION_REG^80H	;  .
 MOVLW	B'10100000'	;  =   .
 MOVWF	INTCON		;
 MOVLW	B'00100000'	;RA0-RA4 -  , RA5 - .
 MOVWF	TRISA^80H
 MOVLW	B'00000000'	;RB0-RB7 -  .
 MOVWF	TRISB^80H
 CLRF	VRCON
 CLRF	PCON		;
 BCF	STATUS,RP0	;   0.
 CLRF	RCSTA		;
 CLRF	PORTB		; .
 CLRF	PORTA		;
 CLRF	FLAG		;  
 CLRF	FLAG1
 CLRF	FLAG3
 CLRF	T1CON		;   
 CLRF	T2CON
 CLRF	TMR0
 MOVLW	.7
 MOVWF	CMCON
 CLRF	KYPC
 CLRF	REID
 CLRF	SECL
 CLRF	SECH
 CLRF	MINL
 CLRF	MINH
 CLRF	HOUL
 CLRF	HOUH
 MOVLW	.253	;
 MOVWF	BUH1H	; 
 MOVWF	BUH1L	;.
 MOVWF	BUM1H	;
 MOVWF	BUM1L	;
 MOVWF	BUH2H	;
 MOVWF	BUH2L	;
 MOVWF	BUM2H	;
 MOVWF	BUM2L	;
 CLRF	SMC
 CLRF	VUX
 CLRF	VUXY
 CLRF	DES
 CLRF	COUE
 CLRF	COUP
 MOVLW	.0
 MOVWF	KOP
 MOVWF	KOP1
 MOVWF	KOP2
 MOVWF	KOP0
 MOVLW	.1
 MOVWF	KYPC
 GOTO	JEKINI	;   LCD.
;===================================
; 23.   .
;===================================
INDYV
	BCF	FLAG,1	;  .
	BTFSC	FLAG,7	;  ,
	GOTO	PROSI	;   .
	BSF	FLAG,7	;  .
	MOVLW	.5	;  
	MOVWF	KYPC	; .
;=============================================
; 24.    .
;=============================================
PROSI
	MOVFW	VUXY	;  .
	MOVWF	R1	;  .
	MOVLW	.18	; "".
	MOVWF	R2	;
	BTFSC	FLAG3,0	;  ,
	MOVLW	.27	;   "".
	BTFSS	FLAG3,0	;
	MOVLW	.147	; - "".
	MOVWF	R3	;
	MOVLW	.240	;.
	MOVWF	R4	;
	MOVFW	BUH1H	; .
	MOVWF	R5	;  .
	MOVFW	BUH1L	;.
	MOVWF	R6	;
	MOVFW	BUM1H	; .
	MOVWF	R7	;
	MOVFW	BUM1L	;.
	MOVWF	R8	;
	MOVLW	.240	;.
	MOVWF	R9	;
	MOVLW	.18	; "".
	MOVWF	R10	;
	MOVLW	.147	; "".
	MOVWF	R11	;
	MOVLW	.240	;.
	MOVWF	R12	;
	MOVFW	BUH2H	; .
	MOVWF	R13	;  .
	MOVFW	BUH2L	;.
	MOVWF	R14	;
	MOVFW	BUM2H	; .
	MOVWF	R15	;
	MOVFW	BUM2L	;.
	MOVWF	R16	;
	RETURN		;
;============================================
; 25.     .
;============================================
INDYK
	BSF	FLAG1,0	;.
	BCF	FLAG,0	;  .
	BCF	FLAG,7	;  .
	BTFSC	FLAG,1	;   ,
	GOTO	$+4	;   .
	BSF	FLAG,1	; .
	MOVLW	.9	;  
	MOVWF	KYPC	;.
	MOVLW	.27	;.
	MOVWF	R1	;
	MOVLW	.63	;.
	MOVWF	R2	;
	MOVLW	.64	;.
	MOVWF	R3	;
	MOVLW	.254	;.
	MOVWF	R4	;
	MOVLW	.240	;.
	MOVWF	R5	;
	MOVWF	R6	;
	MOVWF	R7	;
	MOVWF	R8	;
	MOVWF	R13	;
	MOVWF	R14	;
	MOVWF	R15	;
	MOVWF	R16	;
	BTFSC	FLAG,5	;   ,
	MOVLW	.253	;  .
	BTFSS	FLAG,5	;
	MOVLW	.251	; - .
	MOVWF	R9	;
	MOVFW	KOP0	; .
	MOVWF	R10	;
	MOVFW	KOP1	; .
	MOVWF	R11	;
	MOVFW	KOP2	; .
	MOVWF	R12	;
	RETURN		;
;=================================================
; 26.     2_10 .
;=================================================
BINDEC
	CLRF	BUH1L	;
	CLRF	BUH1H	;
	CLRF	BUM1L	;
	CLRF	BUM1H	;
	CLRF	BUH2L	;
	CLRF	BUH2H	;
	CLRF	BUM2L	;
	CLRF	BUM2H	;
	CLRF	DES	;
	MOVFW	BUH1	; 
	MOVWF	EDI	;.
	CALL	DEC	; .
	MOVWF	BUH1L	;   .
	MOVFW	DES	; 
	MOVWF	BUH1H	;   .
	CLRF	DES	; .
	MOVFW	BUM1	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUM1L	;
	MOVFW	DES	;
	MOVWF	BUM1H	;
	CLRF	DES	;
	MOVFW	BUH2	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUH2L	;
	MOVFW	DES	;
	MOVWF	BUH2H	;
	CLRF	DES	;
	MOVFW	BUM2	;
	MOVWF	EDI	;
	CALL	DEC	;
	MOVWF	BUM2L	;
	MOVFW	DES	;
	MOVWF	BUM2H	;
	CLRF	DES	;
	RETURN		;
DEC
	MOVLW	.10	;
	BSF	STATUS,0;
	SUBWF	EDI,1	;
	BNC	$+3	;
	INCF	DES,1	;
	GOTO	$-5	;
	MOVLW	.10	;
	ADDWF	EDI,0	;
	RETURN		;
;===============================================
; 27.   /.
;===============================================
POUCK
        BSF     FLAG1,7	;   .
	CLRF	COUP	;  .
POUC
        MOVFW   COUP	;  
	CALL	AKTETE	;   .
	MOVWF	TEMP	;.
        ANDLW   B'00011111'; 
	SUBWF	HOU,0	;   .
	SKPZ		; ,
	GOTO	CPLUS	;   .
	MOVLW	.64	; ,
	ADDWF	COUP,0	;    .
	CALL	AKTETE	;  .
	MOVWF	TEMP1	;.
        ANDLW   B'00111111'; 
	SUBWF	MIN,0	;  .
	SKPZ		; ,
	GOTO	CPLUS	;   .
	BTFSS	TEMP1,7	; ,  
	BCF	FLAG1,2	; .
	BTFSC	TEMP1,7	;  ,
	BSF	FLAG1,2	;  .
	SWAPF	TEMP,0	;  .
	ANDLW	B'00001111';
	MOVWF	VUX	;   .
	BCF	STATUS,0;  
	RRF	VUX,1	;  .
        GOTO    PCUX	;,   .
CPLUS
	INCF	COUP,1	;  .
	MOVLW	.64	;  63.
	SUBWF	COUP,0	;
	SKPZ		;
	GOTO	POUC	; .
	CLRF	COUP	;   ,  .
	RETURN		;
;===================================================================
; 28.       .
;===================================================================
CONST
	MOVWF  W_TEMP      ;   W 
	MOVFW  STATUS      ;STATUS,
	MOVWF  STATUS_TEMP ;
	MOVFW  FSR         ;FSR.
	MOVWF  FSR_TEMP    ;
	CALL   S1          ; 1   .
RECONST                    ;  .
	BCF    INTCON,2    ;  (T0IF)   ( ).
	MOVFW  STATUS_TEMP ; :
	MOVWF  STATUS      ;STATUS,
	MOVFW  FSR_TEMP    ;
	MOVWF  FSR         ;FSR,
	MOVFW  W_TEMP      ;W.
	RETFIE		   ;   .
;=========================================
; 29.  --.
;=========================================
S1
	INCF    SMC,1	;  250.
	MOVLW	.250	;
	SUBWF	SMC,0	;
	SKPZ		;
	RETURN
	CLRF	SMC	;
	BTFSS	FLAG3,1	;   ,
	GOTO	$+3	;   .
	BCF	FLAG3,1	;   .
	RETURN		;.
	BSF	FLAG,2	;  0,25 S.
	BTFSC	FLAG3,3	; 
	GOTO	$+3	; 
	BSF	FLAG3,3	; .
	RETURN		;
	BCF	FLAG3,3	; /  2 (2 )
	BTFSC	FLAG3,4	; 
	GOTO	$+3	; 
	BSF	FLAG3,4	; .
	RETURN		;
	BCF	FLAG3,4	;
SLF
        MOVLW   .9	;  9 ,
        SUBWF   SECL,0	;
        BC      SH	;    .
        INCF    SECL,1	;  .
        RETURN
SH
        CLRF    SECL	; .
        MOVFW   SECH	;  
        ADDLW   -5H	; 5,
        BZ      ML	;  .
        INCF    SECH,1	;   .
        RETURN
ML
	MOVFW	KOP	;
	BTFSS	FLAG,5	;   ,
	GOTO	$+3
	ADDWF	SMC,1	;  ( ).
	GOTO	$+2
	SUBWF	SMC,1	;  ( ).
	BSF	FLAG3,1	; .
        CLRF    SECH	;  .
        BCF     FLAG1,7	;   ( ).
        MOVFW   MINL	;  
        ADDLW   -9H	; 9,
        BZ      MH	;  .
        INCF    MINL,1	;  .
	GOTO	DEBIL	;.
MH
        CLRF    MINL	;  .
        MOVFW   MINH	;  
        ADDLW   -5H	; 5,
        BZ      HL	;  .
        INCF    MINH,1	;   .
	GOTO	DEBIL	;.
HL
        CLRF    MINH	;  .
	CALL	DEBIL	;.
        MOVFW   HOUH	;  
        ADDLW   -2H	; 2,
        BZ      HL4	;  .
        MOVFW   HOUL	;    9,
        ADDLW   -9H	;
        BZ      HH	;  .
        INCF    HOUL,1	;   .
	GOTO	DEBIH	;.
HL4
        MOVFW   HOUL	;  
        ADDLW   -3H	; 3,
        BZ      HH	; .
        INCF    HOUL,1	;  .
	GOTO	DEBIH	;.
HH
        CLRF    HOUL	;  .
        MOVFW   HOUH	;  
        ADDLW   -2H	; ,
        BZ      DL	; .
        INCF    HOUH,1	;   .
	GOTO	DEBIH	;.
DL
        CLRF    HOUH	;  .
	CLRF	HOU	;
	CLRF	MIN	;
        RETURN
DEBIL
	MOVFW	MINH	;
	CALL	DEBIN	;  
	ADDWF	MINL,0	;
	MOVWF	MIN	;.
	RETURN		;
DEBIH
	MOVFW	HOUH	;
	CALL	DEBIN	;  
	ADDWF	HOUL,0	;
	MOVWF	HOU	;.
	RETURN		;
;=======================================
; 30.   
;          .
;=======================================
ZAPIS
	TSTF	VUXY	;    ,
	SKPNZ		;
	GOTO	HYLI	;  .
ZAPI0
	CLRF	COUE	;   .
MECTO
        MOVFW   COUE	;  
	CALL	AKTETE	;   .
	MOVWF	TEMP	;.
	SWAPF	TEMP,0	;  .
	ANDLW	B'00001111';
	MOVWF	VUX	;
	BCF	STATUS,0;
	RRF	VUX,1	;.
	TSTF	VUX	;   ,
	BNZ	ZPLUS	;  ,   . .
	GOTO	SAPIS	;  ,      .
MECTO64
	MOVLW	.64	;  .
	MOVWF	COUE	;  ,   
	MOVFW	COUE	;  .
	CALL	AKTETE	;
	MOVWF	TEMP	;
	BTFSS	TEMP,7	;    ,
	GOTO	ZPMIN	;.
	MOVLW	.2	;    2.
	ADDWF	COUE,1	;
	MOVLW	.128	;  
	SUBWF	COUE,0	;  128.
	BNZ	$-0xA	; .
	GOTO	PYCTO	;
ZPLUS
	MOVLW	.2	;    2.
	ADDWF	COUE,1	;
	MOVLW	.64	;  
	SUBWF	COUE,0	;  64 (0-62).
	BTFSS	STATUS,2;
	GOTO	MECTO	; .
	GOTO	MECTO64	;  .
ZPMIN
	MOVLW	.64	; 
	SUBWF	COUE,1	;   .
	GOTO	SAPIS	; .
HYLI
	CLRF	BUH1	; .
	CLRF	BUM1	;
	CLRF	BUH2	;
	CLRF	BUM2	;
	CLRF	BUH1L	;
	CLRF	BUH1H	;
	CLRF	BUM1H	;
	CLRF	BUM1L	;
	CLRF	BUH2L	;
	CLRF	BUH2H	;
	CLRF	BUM2L	;
	CLRF	BUM2H	;
	BCF	FLAG3,0	; .
;================================
; 31.   .
;================================
SAPIS
	MOVFW	COUE	; 
	MOVWF	ZACON	;.
	MOVFW	BUH1	; 
	MOVWF	BUZAH1	;  .
	MOVFW	BUM1	;
	MOVWF	BUZAM1	;
	MOVFW	BUH2	;
	MOVWF	BUZAH2	;
	MOVFW	BUM2	;
	MOVWF	BUZAM2	;
ZAPVUX
	BTFSC	FLAG3,0	;  ,
	BSF	BUZAM1,7;    .
        SWAPF   VUXY,0	;   
        MOVWF   TEMP	;  .
	BCF	STATUS,0;
        RLF     TEMP,0	;     
	IORWF	BUZAH1,1;   
	IORWF	BUZAH2,1; .
	MOVLW	BUZAH1	;   
	MOVWF	FSR	;   .
	MOVFW	ZACON	;    .
	BSF	STATUS,5; 1.
	BCF	STATUS,6;
	MOVWF	EEADR	; .
        BCF     INTCON,7; .
	CALL	$+0x0E	; .
        INCF    EEADR,1	;+1   .
	INCF	FSR,1	;+1    .
	CALL	$+0x0B	; .
	INCF	FSR,1	;+1    .
	MOVLW	.63	;
	ADDWF	EEADR,1	;+63   .
	CALL	$+0x07	; .
        INCF    EEADR,1	;+1   .
	INCF	FSR,1	;+1    .
	CALL	$+4	; .
        BCF     STATUS,5; 0.
        BSF     INTCON,7; .
	RETURN		;.
	MOVFW	INDF		;  
	MOVWF	EEDATA		;  .
        BSF     EECON1,WREN	; .
        MOVLW   55H		; 
        MOVWF   EECON2		;/
        MOVLW   0AAH		;/
        MOVWF   EECON2		;/
        BSF     EECON1,WR	;    .
        BTFSC   EECON1,WR	;    
        GOTO    $-1		;  .
        BCF     EECON1,WREN	; .
	RETURN			;.
;==================================================
; 32.    .
;==================================================
	ORG     0x2100
	DATA	0xCF, 0xD0, 0xAF, 0xB0, 0x8F, 0x90, 0x20, 0x20
	DATA    0x40, 0x40, 0x40, 0x40, 0x61, 0x61, 0x20, 0x20
	DATA    0xA1, 0xAA, 0x20, 0x20, 0x40, 0x40, 0x60, 0x60
	DATA    0x80, 0x80, 0xA0, 0xA0, 0xC0, 0xC0, 0xC0, 0xC0
	DATA    0x20, 0x20, 0x40, 0x40, 0x60, 0x60, 0x80, 0x80
	DATA    0xA0, 0xA0, 0x20, 0x20, 0x20, 0x20, 0x61, 0x61
	DATA    0x60, 0x60, 0x80, 0x80, 0xA0, 0xA0, 0xC0, 0xC0
	DATA    0x20, 0x20, 0x40, 0x40, 0x60, 0x60, 0x80, 0x80
;
	DATA    0x80, 0x01, 0x80, 0x00, 0x80, 0x00, 0x85, 0x32
	DATA    0x86, 0x0A, 0x85, 0x06, 0x81, 0x03, 0x8B, 0x1E
	DATA    0x81, 0x00, 0x81, 0x02, 0x81, 0x02, 0x81, 0x02
	DATA    0x81, 0x02, 0x81, 0x02, 0x81, 0x02, 0x83, 0x04
	DATA    0x83, 0x04, 0x83, 0x04, 0x83, 0x04, 0x83, 0x04
	DATA    0x83, 0x04, 0x85, 0x06, 0x05, 0x06, 0x01, 0x03
	DATA    0x85, 0x06, 0x85, 0x06, 0x85, 0x06, 0x86, 0x07
	DATA    0x87, 0x08, 0x87, 0x08, 0x87, 0x08, 0x87, 0x08
;============================================================================
	END
;============================================================================
